#define SCOREBOARD_BASE example // Change this to whatever\
variable you want to base your scoreboard on

#define MAX_RANKS 20 // MAX_RANKS is the number of maximum entries\
the scoreboard can have, change this at will as it will not break anything\
in the library.

var/scoreboard/A_SB = new // Creates our scoreboard datum.

scoreboard
	var/list/ranks
	proc/Update(mob/M)
		if(!ranks) ranks = list()
		if(M.key in ranks)
			ranks[M.key] = M.SCOREBOARD_BASE
			UpdateRanks(M.key)
		else
			if(ranks.len < MAX_RANKS)
				ranks[M.key] = M.SCOREBOARD_BASE
			else
				var/Key = ranks[20]
				var/BASE = ranks[Key]
				if(BASE > M.SCOREBOARD_BASE) return
				ranks[Key] = M.key
				ranks[M.key] = M.SCOREBOARD_BASE

	proc/UpdateRanks(key)
		for()
			var/BASE = ranks[key]
			var/INDEX = ranks.Find(key)
			var/NEWINDEX = INDEX - 1
			if(NEWINDEX>MAX_RANKS||NEWINDEX<=0) break
			var/NEWBASE = ranks[ranks[NEWINDEX]]
			if(NEWBASE > BASE)
				ranks.Swap(INDEX,NEWINDEX)
			else break

	proc/Display(mob/M)
		var/counter=1
		var/html= {"<head><title>A_Scoreboard</title></head><body style=\"background-color:black;\"><center><table border=2>
<th colspan=\"3\"><font color=white>Scoreboard library created by Andre-g1
</font color></th><tr><td style=\"background-color: #666666;\"><center><font color=white><b>Name</b></font color></center>
</td><td style=\"background-color: #666666;\"><center><font color=white><b>Value</b></font color></center></td></tr>""}
		for(var/Key in ranks)
			counter++
			var/Value = ranks[Key]
			html += "<tr>[counter%2 ? "<td style=\"background-color: #666666;\">" : "<td>"]<center><font color=white>[Key]</font color></center></td>[counter%2 ? "<td style=\"background-color: #666666;\">" : "<td>"]<center><font color=white>[Value]</font color></center></td></tr>"
		html += "</table></center></p>"
		M << browse(html,"window=A_Scoreboard;can_resize=0;can_minimize=0")